<script lang="ts">
import CombinatorProperties from "@/components/JsonFormRenderers/CombinatorProperties.vue";
import {
  type CombinatorSubSchemaRenderInfo,
  type ControlElement,
  createCombinatorRenderInfos,
  createDefaultValue,
  isAllOfControl,
  type JsonFormsRendererRegistryEntry,
  rankWith,
} from "@jsonforms/core";
import {
  DispatchRenderer,
  rendererProps,
  type RendererProps,
  useJsonFormsAllOfControl,
} from "@jsonforms/vue";
import { DisabledIconFocus, useTranslator, useVuetifyControl } from "@jsonforms/vue-vuetify";
import { defineComponent, ref } from "vue";
import {
  VBtn,
  VCard,
  VCardActions,
  VCardText,
  VCardTitle,
  VDialog,
  VHover,
  VSelect,
  VSpacer,
} from "vuetify/components";

const controlRenderer = defineComponent({
  /* eslint-disable vue/component-definition-name-casing */
  name: "all-of-select-renderer",
  /* eslint-enable */
  components: {
    DispatchRenderer,
    CombinatorProperties,
    VDialog,
    VCard,
    VCardTitle,
    VCardText,
    VCardActions,
    VSpacer,
    VBtn,
    VSelect,
    VHover,
  },
  directives: {
    DisabledIconFocus,
  },
  props: {
    ...rendererProps<ControlElement>(),
  },
  setup(props: RendererProps<ControlElement>) {
    const input = useJsonFormsAllOfControl(props);
    const control = input.control.value;

    const selectedIndex = ref(control.indexOfFittingSchema || 0);
    const selectIndex = ref(selectedIndex.value);
    const newSelectedIndex = ref(0);
    const dialog = ref(false);
    const t = useTranslator();

    const selectedValue = ref(control.data || "");

    const errorMessages = [];

    return {
      ...useVuetifyControl(input),
      selectedIndex,
      selectIndex,
      dialog,
      newSelectedIndex,
      selectedValue,
      t,
      errorMessages,
    };
  },
  computed: {
    indexedAllOfRenderInfos(): (CombinatorSubSchemaRenderInfo & {
      index: number;
    })[] {
      const result = createCombinatorRenderInfos(
        this.control.schema.allOf!,
        this.control.rootSchema,
        "allOf",
        this.control.uischema,
        this.control.path,
        this.control.uischemas,
      );
      return result
        .filter(info => info.uischema)
        .map((info, index) => ({ ...info, index: index }));
    },
  },
  methods: {
    handleSelectChange(newValue: number): void {
      // Determine if the dialog should be shown

      if (this.control.data !== "") {
        this.dialog = true;
        this.$nextTick(() => {
          this.newSelectedIndex = newValue; // Store the new index
          this.selectIndex = this.selectedIndex; // Revert to old index while dialog is open
        });
        setTimeout(() => ((this.$refs.confirm as any).$el as HTMLElement).focus());
      } else {
        // Update indexes and value directly if no dialog is needed
        this.selectedIndex = newValue;
        this.selectIndex = newValue;
        this.selectedValue = this.control.data || ""; // Ensure selectedValue is set
      }
    },
    confirm(): void {
      this.newSelection();
      this.dialog = false;
    },
    cancel(): void {
      this.newSelectedIndex = this.selectedIndex; // Revert selection
      this.dialog = false;
    },
    newSelection(): void {
      const newSchema = this.indexedAllOfRenderInfos[this.newSelectedIndex]?.schema;
      const defaultValue = createDefaultValue(newSchema);

      if (typeof defaultValue === "string") {
        this.handleChange(
          this.path,
          this.newSelectedIndex !== undefined && this.newSelectedIndex !== null ? defaultValue : "",
        );
      }

      this.selectIndex = this.newSelectedIndex;
      this.selectedIndex = this.newSelectedIndex;
      this.selectedValue = defaultValue; // Update selected value
    },
  },
});

export default controlRenderer;

export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(3, isAllOfControl),
};
</script>

<template>
  here 1
  <div v-if="control.visible">
    <CombinatorProperties
      :schema="control.schema"
      combinator-keyword="allOf"
      :path="path"
    />
    <VHover v-slot="{ isHovering }">
      <VSelect
        :id="`${control.id}-input`"
        v-model="selectIndex"
        v-disabled-icon-focus
        :class="styles.control.input"
        :disabled="!control.enabled"
        :autofocus="appliedOptions.focus"
        :placeholder="appliedOptions.placeholder"
        :label="computedLabel"
        :hint="control.description"
        :persistent-hint="persistentHint()"
        :required="control.required"
        :error-messages="errorMessages"
        :clearable="isHovering"
        :items="indexedAllOfRenderInfos"
        :item-title="(item) => t(item.label, item.label)"
        item-value="index"
        v-bind="vuetifyProps('v-select')"
        @update:modelValue="handleSelectChange"
        @focus="isFocused = true"
        @blur="isFocused = false"
      />
    </VHover>

    <!-- Render the selected schema -->
    <DispatchRenderer
      v-if="selectedIndex !== undefined && selectedIndex !== null"
      :schema="indexedAllOfRenderInfos[selectedIndex].schema"
      :uischema="indexedAllOfRenderInfos[selectedIndex].uischema"
      :path="control.path"
      :renderers="control.renderers"
      :cells="control.cells"
      :enabled="control.enabled"
    />

    <!-- Confirmation dialog for clearing form -->
    <VDialog
      v-model="dialog"
      persistent
      max-width="600"
      @keydown.esc="cancel"
    >
      <VCard>
        <VCardTitle class="text-h5">
          Clear form?
        </VCardTitle>
        <VCardText>
          Your data will be cleared if you select this new option. Do you want to proceed?
        </VCardText>
        <VCardActions>
          <VSpacer />
          <VBtn text @click="cancel">
            No
          </VBtn>
          <VBtn
            ref="confirm"
            text
            @click="confirm"
          >
            Yes
          </VBtn>
        </VCardActions>
      </VCard>
    </VDialog>
  </div>
</template>
